/**
Copyright: 2024 Contrast Security, Inc
  Contact: support@contrastsecurity.com
  License: Commercial

  NOTICE: This Software and the patented inventions embodied within may only be
  used as part of Contrast Security’s commercial offerings. Even though it is
  made available through public repositories, use of this Software is subject to
  the applicable End User Licensing Agreement found at
  https://www.contrastsecurity.com/enduser-terms-0317a or as otherwise agreed
  between Contrast Security and the End User. The Software may not be reverse
  engineered, modified, repackaged, sold, redistributed or otherwise used in a
  way not consistent with the End User License Agreement.
*/
'use strict';

const path = require('path');
const process = require('process');
const isAgentPath = require('../../util/is-agent-path');
const defaultPolicy = require('../policy/deadzones.json');
const policyUtil = require('../policy/util');

const isNativeDeadzoned = (isNative, value, key, idOrFile) =>
  isNative && value.native && idOrFile.includes(key);

const isExternalDeadzoned = (isNative, value, key, idOrFile) =>
  !isNative &&
  !value.native &&
  idOrFile.includes(path.join('node_modules', key));

module.exports = class RewriteDeadzones {
  constructor(agent, deadzones = defaultPolicy.deadzones) {
    this.deadzones = deadzones;
    const cfg = agent.config;
    ((cfg.agent && cfg.agent.node.unsafe.deadzones) || []).forEach(
      (deadzone) => {
        this.deadzones[deadzone] = { enabled: true };
      }
    );
  }

  /**
   * Checks whether a module is deadzone for being rewritten by checking
   * its filename against configured agent paths and policies.
   * @param {string} idOrFile
   * @returns {boolean}
   */
  isDeadzoned(idOrFile) {
    // allows us to rewrite normally during unit tests
    if (!process.env.CONTRAST_REWRITE_ALLOWLIST && isAgentPath(idOrFile))
      return true;

    const isNative = idOrFile in process.binding('natives');
    for (const [key, value] of Object.entries(this.deadzones || {})) {
      if (
        isNativeDeadzoned(isNative, value, key, idOrFile) ||
        isExternalDeadzoned(isNative, value, key, idOrFile)
      ) {
        return policyUtil.isEnabled(value);
      }
    }
    return false;
  }
};
